<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/timing_system/ProtoDUNE_TimingSystem/outputlogic_crc16.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_570b4db95f0cd4dd051651dda45f74e5.html">timing_system</a></li><li class="navelem"><a class="el" href="dir_62f6c400dcf184b6e78f244d6857593d.html">ProtoDUNE_TimingSystem</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">outputlogic_crc16.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">-- Copyright (C) </span><span class="vhdllogic">2009</span> OutputLogic.com <span class="keyword"></span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">-- This source <span class="vhdlkeyword">file</span> may be used <span class="vhdlkeyword">and</span> distributed without restriction </span><span class="keyword"></span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">-- provided that this copyright statement <span class="vhdlkeyword">is</span> <span class="vhdlkeyword">not</span> removed from the <span class="vhdlkeyword">file</span> </span><span class="keyword"></span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">and</span> that any derivative work contains the original copyright notice </span><span class="keyword"></span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">and</span> the associated disclaimer. </span><span class="keyword"></span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">-- </span><span class="keyword"></span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">-- THIS SOURCE <span class="vhdlkeyword">FILE</span> <span class="vhdlkeyword">IS</span> PROVIDED &quot;AS IS&quot; <span class="vhdlkeyword">AND</span> WITHOUT ANY EXPRESS </span><span class="keyword"></span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">-- <span class="vhdlkeyword">OR</span> IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED    </span><span class="keyword"></span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">-- WARRANTIES <span class="vhdlkeyword">OF</span> MERCHANTIBILITY <span class="vhdlkeyword">AND</span> FITNESS <span class="vhdlkeyword">FOR</span> A PARTICULAR PURPOSE. </span><span class="keyword"></span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">-- CRC module <span class="vhdlkeyword">for</span> data(</span><span class="vhdllogic">7</span>:<span class="vhdllogic">0</span>)<span class="keyword"></span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">--   lfsr(</span><span class="vhdllogic">15</span>:<span class="vhdllogic">0</span>)=1+x^2+x^15+x^16;<span class="keyword"></span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">-------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">ieee</span>; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keywordflow">entity </span><a class="code" href="classoutputlogic__crc16.html">outputlogic_crc16</a> <span class="vhdlkeyword">is</span> </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;  <span class="vhdlkeyword">port</span> <span class="vhdlchar">(</span> <span class="vhdlchar">data_in</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic_vector</span> <span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="vhdlchar">crc_en</span> <span class="vhdlchar">,</span> <span class="vhdlchar">rst</span><span class="vhdlchar">,</span> <span class="vhdlchar">clk</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="vhdlchar">crc_out</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span> <span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlchar">outputlogic_crc16</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="vhdlkeyword">architecture</span> imp_crc <span class="vhdlkeyword">of</span> <a class="code" href="classoutputlogic__crc16.html">outputlogic_crc16</a> is    </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span> <span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;    </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span> <span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;    </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="vhdlkeyword">begin</span>   </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="vhdlchar">crc_out</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">9</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">10</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">11</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">12</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">13</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">14</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">5</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">6</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">9</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">10</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">11</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">12</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">13</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">14</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">5</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">6</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">9</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">9</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">10</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">10</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">11</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">5</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">11</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">12</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">6</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">12</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">13</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">5</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">13</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">14</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">5</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">6</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">14</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">6</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">9</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">10</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">11</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">12</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">13</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">5</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">14</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">6</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="vhdlchar">lfsr_c</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">8</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">9</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">10</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">11</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">12</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">13</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">14</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">lfsr_q</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">4</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">5</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">6</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">xor</span> <span class="vhdlchar">data_in</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">7</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="vhdlkeyword">process</span> (clk,rst) <span class="vhdlkeyword">begin</span> </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;      <span class="vhdlkeyword">if</span> <span class="vhdlchar">(</span><span class="vhdlchar">clk</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">EVENT</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">clk</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span> </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="vhdlkeyword">if</span> <span class="vhdlchar">(</span><span class="vhdlchar">rst</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span> </div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            <span class="vhdlchar">lfsr_q</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">b</span><span class="vhdllogic">&quot;1111111111111111&quot;</span>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">(</span><span class="vhdlchar">crc_en</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span> </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;          <span class="vhdlchar">lfsr_q</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">lfsr_c</span>; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>; </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;      <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">architecture</span> <span class="vhdlchar">imp_crc</span>; </div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:30 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
